% (c) Wojciech Paszke, ISSI
% e-mail: w.paszke@issi.uz.zgora.pl

close all  % zamykamy wszytkie okna
clear all  % czycimy wszystkie zmienne
clc % czycimy ekran
%% parametry wahada ktre jest w sali 406

 M = 4.2774;  % masa wzka [kg]
 m = 0.3211;  % masa wahadla [kg]
 l = 0.3533;  % dlugosc wahadla [m]
 Jt = 0.072;  % Jt=J+m*l^2 [kgm^2], gdzie J - moment bezwladnosci w odniesieniu do srodka ciezkosci
 gamma=10.0;  % Staa tarcia prdkosciowego [kg/s]
 c=0.023;     % staa tarcia wahada [kgm^2/s]
 g=9.81;      % przyspieszenie ziemskie [m/s^2]
 
 Mt=m+M;
 mu=Mt*Jt-m^2*l^2;
 
 % Model w przestrzeni stanw na podstawie ksiaki
 
  A=[0, 0, 1, 0;...
    0, 0, 0, 1;... 
    0, m^2*l^2*g/mu, -c*Jt/mu, -gamma*l*m/mu;...
    0, Mt*m*g*l/mu, -c*l*m/mu, -gamma*Mt/mu];

 B=[0; 0; Jt/mu; l*m/mu];

 C=[1,0,0,0; 0,1,0,0];   % dwa wyjcia: polozenie wozka i kat odchylenia wahadla
 
 D=[0;0];
 
sim('InvertedPendulum')

plot(polozenie.time, polozenie.signals.values(:,1),'-r',polozenie.time, polozenie.signals.values(:,2),'-g')
title('Polozenie wozka')
legend('uklad nieliniowy','uklad liniowy');
grid on;
figure;
plot(odchylenie.time, odchylenie.signals.values(:,1),'-r',odchylenie.time, odchylenie.signals.values(:,2),'-g')
title('Odchylenie wahadla')
legend('uklad nieliniowy','uklad liniowy');
grid on;
